﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace Transformations
{
    public partial class FormMain : Form
    {

        Rectangle rect = new Rectangle(0, 0, 200, 200);
        Region regionTransform;
        Graphics gMeasure;

        public FormMain()
        {
            InitializeComponent();
            gMeasure = this.CreateGraphics();
            TransformGraphics(gMeasure);
        }

        private void TransformGraphics(Graphics g) {
            g.TranslateTransform(400, 100);
            g.RotateTransform(45);
            g.ScaleTransform(0.75f, 1.25f);
        }


        private void FormMain_Paint(object sender, PaintEventArgs e)
        {
            Graphics g = e.Graphics;
            g.DrawRectangle(Pens.Black, rect);
            GraphicsState oldState = g.Save();
            TransformGraphics(g);
            g.DrawRectangle(Pens.Red, rect);
            g.Restore(oldState);
        }

        private void FormMain_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                if (rect.Contains(e.Location))
                {
                    toolStripStatusLabelHit.Text = "Hit Device";
                }
                else
                {
                    toolStripStatusLabelHit.Text = "Miss Device";
                }
            }
            else
            {
                Point[] pts = new Point[] { e.Location };
                gMeasure.TransformPoints(CoordinateSpace.World, CoordinateSpace.Device, pts);

                if (rect.Contains(pts[0]))
                {
                    toolStripStatusLabelHit.Text = "Hit World";
                }
                else
                {
                    toolStripStatusLabelHit.Text = "Miss World";
                }
            }
        }

        private void FormMain_MouseMove(object sender, MouseEventArgs e)
        {
            toolStripStatusLabelHit.Text = "";
        }
    }
}
